/* Project: Robotik-Praktikum - "Rug Warrior"                                                                              */
/* File   : "AUFG_1A.C"                                                                                                    */
/* Author : Lars Ferner                                                                                                    */
/* Date   : 96-02-26 / 95-12-07                                                                                            */
/* Notes  : ungeregeltes Fahren eines Quadrates                                                                            */


/* Global constants                                                                                                        */

float DT = 0.1;
float CLICKS_PER_M = MARKINGS / WHEEL_GIRTH;
float CLICKS_PER_DEGREE = CLICKS_PER_M * M_PI * WHEEL_TRACK / 360.0;


/* Global variables                                                                                                        */

int v0 = 0, w0 = 0;


/* Main function                                                                                                           */

void main( void )
/* setzt den Betriebsmodus in Abhaengigkeit von der "persistenten" Variable 'mode'                                         */
{
	if ( mode == 1 )                                        /* "Ruhe"-Modus                                                 */
	{
		mode = 2;

		motor( LEFT, 0 );
		motor( RIGHT, 0 );
	}
	else if ( mode == 2 )
	{
		mode = 1;                                            /* sollte das Fahren des Quadrates durch ein Reset unterbrochen */

		init_motors();
		init_velocity();
																			  /* werden, zunaechst in den "Ruhe"-Modus verzweigen             */
		printf( "Fahre...\n" );

		square();

		printf( "Fertig!\n" );

		mode = 2;                                            /* wurde ein vollstaendiges Quadrat gefahren, beim naechsten    */
	}                                                       /* Reset gleich wieder in diesen Teil verzweigen                */
	else
		mode = 2;                                            /* Initialisieren der Variable 'mode' beim ersten Durchlauf     */
}


/* Functions (definitions)                                                                                                 */

void move( float v, float w )
/* vw-Schnittstelle: berechnet aus 'v' und 'w' die dem linken/rechten Motor zuzufuehrende Leistung                         */
{
	if ( v >  0.8 ) v =  0.8;
	if ( v < -0.8 ) v = -0.8;
	if ( w >  180.0 ) w =  180.0;
	if ( w < -180.0 ) w = -180.0;

	v0 = (int) ( 100.0 * CLICKS_PER_M * v * DT );           /* in 100'stel "clicks"                                         */
	w0 = (int) ( 100.0 * CLICKS_PER_DEGREE * w * DT );      /* in 100'stel "clicks"                                         */

	motor( LEFT, ( v0 - w0 ) / 4 );
	motor( RIGHT, ( v0 + w0 ) / 4 );
}

