/* Project: Robotik-Praktikum - "Rug Warrior"                                                                              */
/* File   : "PSD.C"                                                                                                        */
/* Author : Lars Ferner, Uni Kaiserslautern                                                                                */
/* Date   : 96-03-25 / 96-03-25                                                                                            */
/* Notes  : Beispiel fuer die Benutzung der Assembler-Routinen zur Ansteuerung des PSD GP2D02                              */


/* Global constants                                                                                                        */

/* Die folgende Tabelle ist nur ein Beispiel! Sie muss konkret fuer jeden Sensor ausgemessen werden.                       */
/* Dabei sollte nicht wie in diesem Beispiel jeder 5. Wert beruecksichtigt werden, sondern besser jeder 2. !               */


int DISTANCE[] = { 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 65, 70, 75, 80, 85, 90, 95, 100, 105, 110, 115,
						 120, 130, 140, 150, 160, 170, 190, 200, 210, 230, 260, 300, 340, 380, 440, 500, 590, 790, 1000,
						 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000 };


/* Functions (definitions)                                                                                                 */

int psd( void )
/* Messung mit PSD-Sensor durchfuehren und ueber Tabelle die entspr. Entfernung in mm zurueckgeben.                        */
{
	/* Local variables                                                                                                 */

	long MeasureCycle;


	StartPSD( 0 );

	MeasureCycle = mseconds() + 50L;                        /* 50 ms warten                                             */
	while( MeasureCycle > mseconds() );

	return ( DISTANCE[GetPSD( 0 ) / 5] );
}

