/* Project: Robotik-Praktikum - "Rug Warrior"                                                                              */
/* File   : "SQUARE.C"                                                                                                     */
/* Author : Lars Ferner                                                                                                    */
/* Date   : 96-02-26 / 96-02-26                                                                                            */
/* Notes  : Bewegungsroutinen zum Fahren eines Quadrates                                                                   */


/* Global constants                                                                                                        */

float DEGREE_PER_M = 360.0 / M_PI / WHEEL_TRACK;           /* fuer Drehung um ein Rad                                      */


/* Functions (definitions)                                                                                                 */

void square( void )
/* 4 Mal 1 Meter geradeaus fahren und um 90 Grad drehen -> ein Quadrat fahren                                              */
{
	/* Local variables                                                                                                      */

	int i;


	for ( i = 0; i < 4; i++ )
	{
		forward();
		turn_right();
	}

	turn_left();
}

void forward( void )
/* 1 Meter geradeaus fahren                                                                                                */
{
	reset_odometer( RIGHT );
	move( 0.15, 0.0 );
	while ( odometer( RIGHT ) < 0.8 );
	move( 0.10, 0.0 );
	while ( odometer( RIGHT ) < 1.0 );
	move( 0.0, 0.0 );
	msleep( 1000L );
}

void turn_right( void )
/* um 90 Grad nach rechts drehen                                                                                           */
{
	/* Local constants                                                                                                     */

	float ARC = 2.0 * M_PI * WHEEL_TRACK / 4.0;
	

	reset_odometer( LEFT );
	move( 0.05, -0.05 * DEGREE_PER_M );
	while ( odometer( LEFT ) < ARC );
	move( 0.0, 0.0 );
	msleep( 1000L );
}

void turn_left( void )
/* um 360 Grad nach links drehen                                                                                           */
{
	/* Local constants                                                                                                     */

	float ARC = 2.0 * M_PI * WHEEL_TRACK;
	

	reset_odometer( RIGHT );
	move( 0.05, 0.05 * DEGREE_PER_M );
	while ( odometer( RIGHT ) < ARC );
	move( 0.0, 0.0 );
	msleep( 1000L );
}
